/****************************************************************************
Prolog to Wam Compiler                     INRIA Rocquencourt - ChLoE Project
Version 2.21                                               Daniel Diaz - 1994

File : fd_interp.c
Main : no_main
****************************************************************************/

#define DEBUG_LEVEL    0

#include "wam_engine.h"
#include "fd_engine.h"

#include "fd_interp.h"
#include "fd_interp.usr"


#define ASCII_PRED "in"
#define PRED       X696E
#define ARITY      2

Begin_Public_Pred
      pragma_c(Meta_Fd_Cstr_2)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#="
#define PRED       X233D
#define ARITY      2

Begin_Public_Pred
      allocate(5)
      put_y_variable(4,2)
      put_y_variable(3,3)
      put_y_variable(2,4)
      put_y_variable(1,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(4,0)
      put_y_value(3,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_unsafe_value(2,0)
      put_y_unsafe_value(1,1)
      put_y_unsafe_value(0,2)
      deallocate
      execute(Pred_Name(X65715F766172,3),1,"eq_var",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#\\="
#define PRED       X235C3D
#define ARITY      2

Begin_Public_Pred
      allocate(6)
      put_y_variable(5,2)
      put_y_variable(4,3)
      put_y_variable(3,4)
      put_y_variable(2,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_variable(1,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_unsafe_value(1,0)
      put_y_unsafe_value(0,1)
      deallocate
      execute(Pred_Name(X783C3E79,2),0,"x<>y",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#>="
#define PRED       X233E3D
#define ARITY      2

Begin_Public_Pred
      allocate(6)
      put_y_variable(5,2)
      put_y_variable(4,3)
      put_y_variable(3,4)
      put_y_variable(2,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_variable(1,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_unsafe_value(1,0)
      put_y_unsafe_value(0,1)
      deallocate
      execute(Pred_Name(X783E3D79,2),0,"x>=y",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#>"
#define PRED       X233E
#define ARITY      2

Begin_Public_Pred
      allocate(6)
      put_y_variable(5,2)
      put_y_variable(4,3)
      put_y_variable(3,4)
      put_y_variable(2,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_variable(1,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_unsafe_value(1,0)
      put_y_unsafe_value(0,1)
      deallocate
      execute(Pred_Name(X783E79,2),0,"x>y",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#<="
#define PRED       X233C3D
#define ARITY      2

Begin_Public_Pred
      allocate(6)
      put_y_variable(5,2)
      put_y_variable(4,3)
      put_y_variable(3,4)
      put_y_variable(2,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_variable(1,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_unsafe_value(1,0)
      put_y_unsafe_value(0,1)
      deallocate
      execute(Pred_Name(X783E3D79,2),0,"x>=y",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "#<"
#define PRED       X233C
#define ARITY      2

Begin_Public_Pred
      allocate(6)
      put_y_variable(5,2)
      put_y_variable(4,3)
      put_y_variable(3,4)
      put_y_variable(2,5)
      call(Pred_Name(X6E6F726D616C697A65,6),1,1,"normalize",6)          /* begin sub 1 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,2,"eq_var",3)          /* begin sub 2 */
      put_y_value(3,0)
      put_y_value(2,1)
      put_y_variable(1,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_unsafe_value(1,0)
      put_y_unsafe_value(0,1)
      deallocate
      execute(Pred_Name(X783E79,2),0,"x>y",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var"
#define PRED       X65715F766172
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(2),G_label(3),fail,G_label(1),fail)

label(1)
      try(5,1)          /* begin sub 1 */
      retry(7,2)          /* begin sub 2 */
      trust(9)

label(2)
      try_me_else(4)

label(3)
      get_nil(0)
      get_x_value(1,2)
      proceed

label(4)
      retry_me_else(6)

label(5)
      get_list(0)
      unify_x_variable(0)
      unify_nil
      get_structure(X2A,2,0,"*")
      unify_x_variable(0)
      unify_x_variable(5)
      get_x_variable(4,1)
      get_x_variable(3,2)
      neck_cut
      put_x_value(5,1)
      put_x_value(4,2)
      execute(Pred_Name(X65715F7661725F2461757831,4),1,"eq_var_$aux1",4)

label(6)
      retry_me_else(8)

label(7)
      get_list(0)
      unify_x_variable(0)
      unify_x_variable(3)
      get_structure(X2A,2,0,"*")
      unify_x_variable(0)
      unify_x_variable(7)
      get_list(3)
      unify_x_variable(3)
      unify_nil
      get_structure(X2A,2,3,"*")
      unify_x_variable(6)
      unify_x_variable(3)
      get_x_variable(4,1)
      get_x_variable(5,2)
      neck_cut
      put_x_value(7,1)
      put_x_value(6,2)
      execute(Pred_Name(X65715F7661725F2461757833,6),1,"eq_var_$aux3",6)

label(8)
      trust_me_else_fail

label(9)
      allocate(6)
      get_list(0)
      unify_x_variable(3)
      unify_x_variable(0)
      get_structure(X2A,2,3,"*")
      unify_y_variable(5)
      unify_y_variable(4)
      get_list(0)
      unify_x_variable(3)
      unify_x_variable(0)
      get_structure(X2A,2,3,"*")
      unify_y_variable(3)
      unify_y_variable(2)
      get_y_variable(1,2)
      neck_cut
      put_y_variable(0,2)
      call(Pred_Name(X65715F766172,3),1,3,"eq_var",3)          /* begin sub 3 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_value(3,2)
      put_y_value(2,3)
      put_y_value(1,4)
      put_y_unsafe_value(0,5)
      deallocate
      execute(Pred_Name(X65715F7661725F2461757837,6),1,"eq_var_$aux7",6)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux1"
#define PRED       X65715F7661725F2461757831
#define ARITY      4

Begin_Private_Pred
      try_me_else(1)
      get_integer(0,2)
      neck_cut
      put_x_value(3,2)
      execute(Pred_Name(X65715F7661725F2461757832,3),1,"eq_var_$aux2",3)

label(1)
      retry_me_else(2)
      get_integer(1,0)
      neck_cut
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(3,2)
      execute(Pred_Name(X782B633D79,3),0,"x+c=y",3)

label(2)
      trust_me_else_fail
      execute(Pred_Name(X61782B633D79,4),0,"ax+c=y",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux2"
#define PRED       X65715F7661725F2461757832
#define ARITY      3

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,0)
      neck_cut
      get_x_value(2,1)
      proceed

label(1)
      trust_me_else_fail
      execute(Pred_Name(X61783D79,3),0,"ax=y",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux3"
#define PRED       X65715F7661725F2461757833
#define ARITY      6

Begin_Private_Pred
      try_me_else(1)
      get_integer(0,4)
      neck_cut
      put_x_value(5,4)
      execute(Pred_Name(X65715F7661725F2461757834,5),1,"eq_var_$aux4",5)

label(1)
      retry_me_else(2)
      get_integer(1,0)
      neck_cut
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(3,2)
      put_x_value(4,3)
      put_x_value(5,4)
      execute(Pred_Name(X65715F7661725F2461757836,5),1,"eq_var_$aux6",5)

label(2)
      retry_me_else(3)
      get_integer(1,2)
      neck_cut
      put_x_value(3,2)
      put_x_value(4,3)
      put_x_value(5,4)
      execute(Pred_Name(X61782B792B633D7A,5),0,"ax+y+c=z",5)

label(3)
      trust_me_else_fail
      execute(Pred_Name(X61782B62792B633D7A,6),0,"ax+by+c=z",6)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux4"
#define PRED       X65715F7661725F2461757834
#define ARITY      5

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,0)
      neck_cut
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(3,2)
      put_x_value(4,3)
      execute(Pred_Name(X65715F7661725F2461757835,4),1,"eq_var_$aux5",4)

label(1)
      retry_me_else(2)
      get_integer(1,2)
      neck_cut
      put_x_value(3,2)
      put_x_value(4,3)
      execute(Pred_Name(X61782B793D7A,4),0,"ax+y=z",4)

label(2)
      trust_me_else_fail
      execute(Pred_Name(X61782B62793D7A,5),0,"ax+by=z",5)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux5"
#define PRED       X65715F7661725F2461757835
#define ARITY      4

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,1)
      neck_cut
      put_x_value(2,1)
      put_x_value(3,2)
      execute(Pred_Name(X782B793D7A,3),0,"x+y=z",3)

label(1)
      trust_me_else_fail
      get_x_variable(4,0)
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(4,2)
      execute(Pred_Name(X61782B793D7A,4),0,"ax+y=z",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux6"
#define PRED       X65715F7661725F2461757836
#define ARITY      5

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,1)
      neck_cut
      put_x_value(2,1)
      put_x_value(3,2)
      put_x_value(4,3)
      execute(Pred_Name(X782B792B633D7A,4),0,"x+y+c=z",4)

label(1)
      trust_me_else_fail
      get_x_variable(5,0)
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(5,2)
      execute(Pred_Name(X61782B792B633D7A,5),0,"ax+y+c=z",5)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux7"
#define PRED       X65715F7661725F2461757837
#define ARITY      6

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,0)
      neck_cut
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(3,2)
      put_x_value(4,3)
      put_x_value(5,4)
      execute(Pred_Name(X65715F7661725F2461757838,5),1,"eq_var_$aux8",5)

label(1)
      retry_me_else(2)
      get_integer(1,2)
      neck_cut
      put_x_value(3,2)
      put_x_value(5,3)
      execute(Pred_Name(X61782B792B7A3D74,5),0,"ax+y+z=t",5)

label(2)
      trust_me_else_fail
      get_x_variable(6,4)
      put_x_value(5,4)
      put_x_value(6,5)
      execute(Pred_Name(X61782B62792B7A3D74,6),0,"ax+by+z=t",6)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "eq_var_$aux8"
#define PRED       X65715F7661725F2461757838
#define ARITY      5

Begin_Private_Pred
      try_me_else(1)
      get_integer(1,1)
      neck_cut
      put_x_value(2,1)
      put_x_value(4,2)
      execute(Pred_Name(X782B792B7A3D74,4),0,"x+y+z=t",4)

label(1)
      trust_me_else_fail
      get_x_variable(6,0)
      get_x_variable(5,3)
      put_x_value(1,0)
      put_x_value(2,1)
      put_x_value(6,2)
      put_x_value(4,3)
      put_x_value(5,4)
      execute(Pred_Name(X61782B792B7A3D74,5),0,"ax+y+z=t",5)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "normalize"
#define PRED       X6E6F726D616C697A65
#define ARITY      6

Begin_Private_Pred
      allocate(11)
      get_x_variable(6,0)
      get_y_variable(4,2)
      get_y_variable(10,3)
      get_y_variable(1,4)
      get_y_variable(9,5)
      get_y_bc_reg(0)
      put_structure(X2D,2,0,"-")
      unify_x_local_value(6)
      unify_x_local_value(1)
      put_integer(1,1)
      put_y_variable(7,2)
      put_y_variable(8,3)
      call(Pred_Name(X6E6F726D616C697A6531,4),1,1,"normalize1",4)          /* begin sub 1 */
      put_y_value(10,0)
      put_y_value(9,1)
      put_y_value(8,2)
      call(Pred_Name(X6E6F726D616C697A655F2461757839,3),1,2,"normalize_$aux9",3)          /* begin sub 2 */
      put_y_value(7,0)
      put_y_variable(6,1)
      put_y_variable(3,2)
      call(Pred_Name(X73706C6974,3),1,3,"split",3)          /* begin sub 3 */
      put_y_value(6,0)
      put_y_variable(5,1)
      call(Pred_Name(X736F7274,2),0,4,"sort",2)          /* begin sub 4 */
      put_y_value(5,0)
      put_nil(1)
      put_y_value(4,2)
      call(Pred_Name(X72657665727365,3),1,5,"reverse",3)          /* begin sub 5 */
      put_y_value(3,0)
      put_y_variable(2,1)
      call(Pred_Name(X736F7274,2),0,6,"sort",2)          /* begin sub 6 */
      put_y_value(2,0)
      put_nil(1)
      put_y_value(1,2)
      call(Pred_Name(X72657665727365,3),1,7,"reverse",3)          /* begin sub 7 */
      cut_y(0)
      deallocate
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "normalize_$aux9"
#define PRED       X6E6F726D616C697A655F2461757839
#define ARITY      3

Begin_Private_Pred
      try_me_else(1)
      math_load_x_value(2,2)
      put_integer(0,3)
      builtin_2(gte,2,3)
      neck_cut
      get_x_value(2,0)
      get_integer(0,1)
      proceed

label(1)
      trust_me_else_fail
      get_integer(0,0)
      math_load_x_value(2,2)
      function_1(neg,0,2)
      get_x_value(1,0)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "normalize1"
#define PRED       X6E6F726D616C697A6531
#define ARITY      4

Begin_Private_Pred
      try_me_else(1)
      allocate(8)
      get_y_variable(6,1)
      get_y_variable(3,2)
      get_y_variable(2,3)
      builtin_1(nonvar,0)
      get_structure(X2B,2,0,"+")
      unify_x_variable(0)
      unify_y_variable(7)
      put_y_value(6,1)
      put_y_variable(5,2)
      put_y_variable(1,3)
      call(Pred_Name(X6E6F726D616C697A6531,4),1,1,"normalize1",4)          /* begin sub 1 */
      put_y_value(7,0)
      put_y_value(6,1)
      put_y_variable(4,2)
      put_y_variable(0,3)
      call(Pred_Name(X6E6F726D616C697A6531,4),1,2,"normalize1",4)          /* begin sub 2 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_value(3,2)
      call(Pred_Name(X617070656E645F776974685F616464,3),1,3,"append_with_add",3)          /* begin sub 3 */
      math_load_y_value(1,1)
      math_load_y_value(0,0)
      function_2(add,0,1,0)
      get_y_value(2,0)
      deallocate
      proceed

label(1)
      retry_me_else(2)
      allocate(8)
      get_y_variable(3,2)
      get_y_variable(2,3)
      builtin_1(nonvar,0)
      get_structure(X2D,2,0,"-")
      unify_x_variable(0)
      unify_y_variable(7)
      math_load_x_value(1,1)
      function_1(neg,2,1)
      get_y_variable(6,2)
      put_y_variable(5,2)
      put_y_variable(1,3)
      call(Pred_Name(X6E6F726D616C697A6531,4),1,4,"normalize1",4)          /* begin sub 4 */
      put_y_value(7,0)
      put_y_value(6,1)
      put_y_variable(4,2)
      put_y_variable(0,3)
      call(Pred_Name(X6E6F726D616C697A6531,4),1,5,"normalize1",4)          /* begin sub 5 */
      put_y_value(5,0)
      put_y_value(4,1)
      put_y_value(3,2)
      call(Pred_Name(X617070656E645F776974685F616464,3),1,6,"append_with_add",3)          /* begin sub 6 */
      math_load_y_value(1,1)
      math_load_y_value(0,0)
      function_2(add,0,1,0)
      get_y_value(2,0)
      deallocate
      proceed

label(2)
      retry_me_else(3)
      get_list(2)
      unify_x_variable(2)
      unify_nil
      get_structure(X2A,2,2,"*")
      unify_x_variable(2)
      unify_x_variable(4)
      get_integer(0,3)
      builtin_1(nonvar,0)
      get_structure(X2A,2,0,"*")
      unify_x_variable(0)
      unify_x_value(4)
      math_load_x_value(1,1)
      math_load_x_value(0,0)
      function_2(mul,0,1,0)
      get_x_value(2,0)
      proceed

label(3)
      retry_me_else(4)
      get_nil(2)
      builtin_1(integer,0)
      math_load_x_value(1,1)
      math_load_x_value(0,0)
      function_2(mul,0,1,0)
      get_x_value(3,0)
      proceed

label(4)
      trust_me_else_fail
      get_list(2)
      unify_x_variable(2)
      unify_nil
      get_structure(X2A,2,2,"*")
      unify_x_local_value(1)
      unify_x_local_value(0)
      get_integer(0,3)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "append_with_add"
#define PRED       X617070656E645F776974685F616464
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      get_x_value(1,2)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(3)
      get_list(0)
      unify_x_variable(0)
      unify_y_variable(2)
      get_structure(X2A,2,0,"*")
      unify_x_variable(4)
      unify_x_variable(3)
      get_y_variable(0,2)
      put_x_value(1,0)
      put_x_value(4,1)
      put_x_value(3,2)
      put_y_variable(1,3)
      call(Pred_Name(X73756D5F696E5F6C697374,4),1,1,"sum_in_list",4)          /* begin sub 1 */
      put_y_value(2,0)
      put_y_unsafe_value(1,1)
      put_y_value(0,2)
      deallocate
      execute(Pred_Name(X617070656E645F776974685F616464,3),1,"append_with_add",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "sum_in_list"
#define PRED       X73756D5F696E5F6C697374
#define ARITY      4

Begin_Private_Pred
      switch_on_term(G_label(2),G_label(3),fail,G_label(1),fail)

label(1)
      try(5,1)          /* begin sub 1 */
      trust(7)

label(2)
      try_me_else(4)

label(3)
      get_nil(0)
      get_list(3)
      unify_x_variable(0)
      unify_nil
      get_structure(X2A,2,0,"*")
      unify_x_local_value(1)
      unify_x_local_value(2)
      proceed

label(4)
      retry_me_else(6)

label(5)
      get_list(0)
      unify_x_variable(0)
      unify_x_variable(5)
      get_structure(X2A,2,0,"*")
      unify_x_variable(0)
      unify_x_variable(4)
      get_list(3)
      unify_x_variable(3)
      unify_x_value(5)
      get_structure(X2A,2,3,"*")
      unify_x_variable(3)
      unify_x_value(4)
      builtin_2(term_eq,4,2)
      math_load_x_value(0,0)
      math_load_x_value(1,1)
      function_2(add,0,0,1)
      get_x_value(3,0)
      proceed

label(6)
      trust_me_else_fail

label(7)
      get_list(0)
      unify_x_variable(4)
      unify_x_variable(0)
      get_list(3)
      unify_x_value(4)
      unify_x_variable(3)
      execute(Pred_Name(X73756D5F696E5F6C697374,4),1,"sum_in_list",4)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "split"
#define PRED       X73706C6974
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(2),G_label(3),fail,G_label(1),fail)

label(1)
      try(5,1)          /* begin sub 1 */
      retry(7,2)          /* begin sub 2 */
      trust(9)

label(2)
      try_me_else(4)

label(3)
      get_nil(0)
      get_nil(1)
      get_nil(2)
      proceed

label(4)
      retry_me_else(6)

label(5)
      get_list(0)
      unify_x_variable(3)
      unify_x_variable(0)
      get_structure(X2A,2,3,"*")
      unify_x_variable(4)
      unify_x_variable(3)
      get_list(1)
      unify_x_variable(5)
      unify_x_variable(1)
      get_structure(X2A,2,5,"*")
      unify_x_value(4)
      unify_x_value(3)
      math_load_x_value(4,4)
      put_integer(0,3)
      builtin_2(gt,4,3)
      execute(Pred_Name(X73706C6974,3),1,"split",3)

label(6)
      retry_me_else(8)

label(7)
      get_list(0)
      unify_x_variable(3)
      unify_x_variable(0)
      get_structure(X2A,2,3,"*")
      unify_x_variable(3)
      unify_x_variable(5)
      get_list(2)
      unify_x_variable(4)
      unify_x_variable(2)
      get_structure(X2A,2,4,"*")
      unify_x_variable(4)
      unify_x_value(5)
      math_load_x_value(3,3)
      put_integer(0,5)
      builtin_2(lt,3,5)
      math_load_x_value(3,3)
      function_1(neg,3,3)
      get_x_value(4,3)
      execute(Pred_Name(X73706C6974,3),1,"split",3)

label(8)
      trust_me_else_fail

label(9)
      get_list(0)
      unify_void(1)
      unify_x_variable(0)
      execute(Pred_Name(X73706C6974,3),1,"split",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "reverse"
#define PRED       X72657665727365
#define ARITY      3

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      get_x_value(1,2)
      proceed

label(3)
      trust_me_else_fail

label(4)
      get_list(0)
      unify_x_variable(4)
      unify_x_variable(0)
      get_x_variable(3,1)
      put_list(1)
      unify_x_value(4)
      unify_x_local_value(3)
      execute(Pred_Name(X72657665727365,3),1,"reverse",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Init_Tables(fd_interp)

 Define_Atom(X5B5D,"[]")
 Define_Atom(X696E,"in")
 Define_Atom(X233D,"#=")
 Define_Atom(X235C3D,"#\\=")
 Define_Atom(X233E3D,"#>=")
 Define_Atom(X233E,"#>")
 Define_Atom(X233C3D,"#<=")
 Define_Atom(X233C,"#<")
 Define_Atom(X65715F766172,"eq_var")
 Define_Atom(X2A,"*")
 Define_Atom(X65715F7661725F2461757831,"eq_var_$aux1")
 Define_Atom(X65715F7661725F2461757832,"eq_var_$aux2")
 Define_Atom(X65715F7661725F2461757833,"eq_var_$aux3")
 Define_Atom(X65715F7661725F2461757834,"eq_var_$aux4")
 Define_Atom(X65715F7661725F2461757835,"eq_var_$aux5")
 Define_Atom(X65715F7661725F2461757836,"eq_var_$aux6")
 Define_Atom(X65715F7661725F2461757837,"eq_var_$aux7")
 Define_Atom(X65715F7661725F2461757838,"eq_var_$aux8")
 Define_Atom(X6E6F726D616C697A65,"normalize")
 Define_Atom(X2D,"-")
 Define_Atom(X6E6F726D616C697A655F2461757839,"normalize_$aux9")
 Define_Atom(X6E6F726D616C697A6531,"normalize1")
 Define_Atom(X2B,"+")
 Define_Atom(X617070656E645F776974685F616464,"append_with_add")
 Define_Atom(X73756D5F696E5F6C697374,"sum_in_list")
 Define_Atom(X73706C6974,"split")
 Define_Atom(X72657665727365,"reverse")


 Define_Pred(X696E,2,1)

 Define_Pred(X233D,2,1)

 Define_Pred(X235C3D,2,1)

 Define_Pred(X233E3D,2,1)

 Define_Pred(X233E,2,1)

 Define_Pred(X233C3D,2,1)

 Define_Pred(X233C,2,1)

 Define_Pred(X65715F766172,3,0)

 Define_Pred(X65715F7661725F2461757831,4,0)

 Define_Pred(X65715F7661725F2461757832,3,0)

 Define_Pred(X65715F7661725F2461757833,6,0)

 Define_Pred(X65715F7661725F2461757834,5,0)

 Define_Pred(X65715F7661725F2461757835,4,0)

 Define_Pred(X65715F7661725F2461757836,5,0)

 Define_Pred(X65715F7661725F2461757837,6,0)

 Define_Pred(X65715F7661725F2461757838,5,0)

 Define_Pred(X6E6F726D616C697A65,6,0)

 Define_Pred(X6E6F726D616C697A655F2461757839,3,0)

 Define_Pred(X6E6F726D616C697A6531,4,0)

 Define_Pred(X617070656E645F776974685F616464,3,0)

 Define_Pred(X73756D5F696E5F6C697374,4,0)

 Define_Pred(X73706C6974,3,0)

 Define_Pred(X72657665727365,3,0)

 Init_Usr_File

End_Init_Tables


Begin_Exec_Directives(fd_interp)



End_Exec_Directives
