/****************************************************************************
Prolog to Wam Compiler                     INRIA Rocquencourt - ChLoE Project
Version 2.21                                               Daniel Diaz - 1994

File : b_bips.c
Main : no_main
****************************************************************************/

#define DEBUG_LEVEL    0

#include "wam_engine.h"
#include "fd_engine.h"

#include "b_bips.h"
#include "b_bips.usr"


#define ASCII_PRED "not"
#define PRED       X6E6F74
#define ARITY      2

Begin_Public_Pred
      fd_set_x_AF(2,2)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_install_constraint_with_x_AF(1,2)
      fd_call_constraint
      fd_install_constraint_with_x_AF(2,2)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(1)

      fd_create_C_frame(1,0,1)
      fd_install_dly_val(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(1)

      fd_dly_val(1,1,1)
      fd_integer(0,1)
      fd_term_sub_term(0,1)
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(2)

      fd_create_C_frame(2,1,1)
      fd_install_dly_val(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(2)

      fd_dly_val(1,0,1)
      fd_integer(0,1)
      fd_term_sub_term(0,1)
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "and"
#define PRED       X616E64
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(3,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(4,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(5,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(6,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(7,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(3)

      fd_create_C_frame(3,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(3)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(4)

      fd_create_C_frame(4,1,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(4)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(5)

      fd_create_C_frame(5,2,1)
      fd_install_ind_min_max(0)
      fd_install_ind_min_max(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(5)

      fd_ind_min_max(5,3,0)
      fd_ind_min_max(4,2,1)
      fd_term_fct(and,1,arg_2(tr(5),tr(4)))
      fd_term_fct(and,0,arg_2(tr(3),tr(2)))
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(6)

      fd_create_C_frame(6,0,1)
      fd_install_ind_min_max(2)
      fd_install_ind_min_max(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(6)

      fd_ind_min_max(1,0,2)
      fd_ind_min_max(2,3,1)
      fd_term_mul_term(0,3)
      fd_integer(3,1)
      fd_term_add_term(0,3)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(7)

      fd_create_C_frame(7,1,1)
      fd_install_ind_min_max(2)
      fd_install_ind_min_max(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(7)

      fd_ind_min_max(1,0,2)
      fd_ind_min_max(2,3,0)
      fd_term_mul_term(0,3)
      fd_integer(3,1)
      fd_term_add_term(0,3)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "or"
#define PRED       X6F72
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(8,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(9,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(10,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(11,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(12,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(8)

      fd_create_C_frame(8,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(8)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(9)

      fd_create_C_frame(9,1,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(9)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(10)

      fd_create_C_frame(10,2,1)
      fd_install_ind_min_max(0)
      fd_install_ind_min_max(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(10)

      fd_ind_min_max(5,3,0)
      fd_ind_min_max(4,2,1)
      fd_term_fct(or,1,arg_2(tr(5),tr(4)))
      fd_term_fct(or,0,arg_2(tr(3),tr(2)))
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(11)

      fd_create_C_frame(11,0,1)
      fd_install_ind_min_max(2)
      fd_install_ind_max(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(11)

      fd_ind_min_max(1,0,2)
      fd_ind_max(3,1)
      fd_integer(2,1)
      fd_term_sub_term(2,3)
      fd_term_mul_term(1,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(12)

      fd_create_C_frame(12,1,1)
      fd_install_ind_min_max(2)
      fd_install_ind_max(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(12)

      fd_ind_min_max(1,0,2)
      fd_ind_max(3,0)
      fd_integer(2,1)
      fd_term_sub_term(2,3)
      fd_term_mul_term(1,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "and0"
#define PRED       X616E6430
#define ARITY      2

Begin_Public_Pred
      fd_set_x_AF(2,2)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_install_constraint_with_x_AF(13,2)
      fd_call_constraint
      fd_install_constraint_with_x_AF(14,2)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(13)

      fd_create_C_frame(13,0,1)
      fd_install_ind_min(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(13)

      fd_ind_min(2,1)
      fd_integer(1,0)
      fd_integer(0,1)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(14)

      fd_create_C_frame(14,1,1)
      fd_install_ind_min(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(14)

      fd_ind_min(2,0)
      fd_integer(1,0)
      fd_integer(0,1)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "or1"
#define PRED       X6F7231
#define ARITY      2

Begin_Public_Pred
      fd_set_x_AF(2,2)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_install_constraint_with_x_AF(15,2)
      fd_call_constraint
      fd_install_constraint_with_x_AF(16,2)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(15)

      fd_create_C_frame(15,0,1)
      fd_install_ind_max(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(15)

      fd_ind_max(0,1)
      fd_integer(1,1)
      fd_term_sub_term(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(16)

      fd_create_C_frame(16,1,1)
      fd_install_ind_max(0)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(16)

      fd_ind_max(0,0)
      fd_integer(1,1)
      fd_term_sub_term(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "and0"
#define PRED       X616E6430
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(17,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(18,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(19,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(17)

      fd_create_C_frame(17,0,1)
      fd_install_ind_min(1)
      fd_install_ind_min(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(17)

      fd_ind_min(2,1)
      fd_ind_min(3,2)
      fd_integer(1,0)
      fd_integer(0,1)
      fd_term_mul_term(2,3)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(18)

      fd_create_C_frame(18,1,1)
      fd_install_ind_min(0)
      fd_install_ind_min(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(18)

      fd_ind_min(2,0)
      fd_ind_min(3,2)
      fd_integer(1,0)
      fd_integer(0,1)
      fd_term_mul_term(2,3)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(19)

      fd_create_C_frame(19,2,1)
      fd_install_ind_min(0)
      fd_install_ind_min(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(19)

      fd_ind_min(2,0)
      fd_ind_min(3,1)
      fd_integer(1,0)
      fd_integer(0,1)
      fd_term_mul_term(2,3)
      fd_term_sub_term(0,2)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "or1"
#define PRED       X6F7231
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(20,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(21,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(22,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(20)

      fd_create_C_frame(20,0,1)
      fd_install_ind_min(1)
      fd_install_ind_min(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(20)

      fd_ind_min(3,1)
      fd_ind_min(2,2)
      fd_integer(1,1)
      fd_term_fct(or,0,arg_2(tr(3),tr(2)))
      fd_term_sub_term(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(21)

      fd_create_C_frame(21,1,1)
      fd_install_ind_min(0)
      fd_install_ind_min(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(21)

      fd_ind_min(3,0)
      fd_ind_min(2,2)
      fd_integer(1,1)
      fd_term_fct(or,0,arg_2(tr(3),tr(2)))
      fd_term_sub_term(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(22)

      fd_create_C_frame(22,2,1)
      fd_install_ind_min(0)
      fd_install_ind_min(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(22)

      fd_ind_min(3,0)
      fd_ind_min(2,1)
      fd_integer(1,1)
      fd_term_fct(or,0,arg_2(tr(3),tr(2)))
      fd_term_sub_term(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "xor"
#define PRED       X786F72
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(23,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(24,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(25,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(26,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(27,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(28,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(23)

      fd_create_C_frame(23,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(23)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(24)

      fd_create_C_frame(24,1,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(24)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(25)

      fd_create_C_frame(25,2,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(25)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(26)

      fd_create_C_frame(26,2,1)
      fd_install_dly_val(0)
      fd_install_dly_val(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(26)

      fd_dly_val(2,0,1)
      fd_dly_val(1,1,1)
      fd_term_fct(xor,0,arg_2(tr(2),tr(1)))
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(27)

      fd_create_C_frame(27,0,1)
      fd_install_dly_val(1)
      fd_install_dly_val(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(27)

      fd_dly_val(2,1,1)
      fd_dly_val(1,2,1)
      fd_term_fct(xor,0,arg_2(tr(2),tr(1)))
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(28)

      fd_create_C_frame(28,1,1)
      fd_install_dly_val(0)
      fd_install_dly_val(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(28)

      fd_dly_val(2,0,1)
      fd_dly_val(1,2,1)
      fd_term_fct(xor,0,arg_2(tr(2),tr(1)))
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "equiv"
#define PRED       X6571756976
#define ARITY      3

Begin_Public_Pred
      fd_set_x_AF(3,3)
      fd_x_value_in_A_frame(0)
      fd_x_value_in_A_frame(1)
      fd_x_value_in_A_frame(2)
      fd_install_constraint_with_x_AF(29,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(30,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(31,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(32,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(33,3)
      fd_call_constraint
      fd_install_constraint_with_x_AF(34,3)
      fd_call_constraint
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Fd_Install(29)

      fd_create_C_frame(29,0,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(29)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(30)

      fd_create_C_frame(30,1,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(30)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(31)

      fd_create_C_frame(31,2,1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(31)

      fd_integer(1,0)
      fd_integer(0,1)
      fd_tell_interval(1,0)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(32)

      fd_create_C_frame(32,2,1)
      fd_install_dly_val(0)
      fd_install_dly_val(1)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(32)

      fd_dly_val(3,0,1)
      fd_dly_val(2,1,1)
      fd_integer(0,1)
      fd_term_fct(xor,1,arg_2(tr(3),tr(2)))
      fd_term_sub_term(0,1)
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(33)

      fd_create_C_frame(33,0,1)
      fd_install_dly_val(1)
      fd_install_dly_val(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(33)

      fd_dly_val(3,1,1)
      fd_dly_val(2,2,1)
      fd_integer(0,1)
      fd_term_fct(xor,1,arg_2(tr(3),tr(2)))
      fd_term_sub_term(0,1)
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint


Begin_Fd_Install(34)

      fd_create_C_frame(34,1,1)
      fd_install_dly_val(0)
      fd_install_dly_val(2)
      fd_proceed

End_Fd_Install


Begin_Fd_Constraint(34)

      fd_dly_val(3,0,1)
      fd_dly_val(2,2,1)
      fd_integer(0,1)
      fd_term_fct(xor,1,arg_2(tr(3),tr(2)))
      fd_term_sub_term(0,1)
      fd_tell_interval(0,0)

   Fd_Label(1)
      fd_proceed

End_Fd_Constraint



#define ASCII_PRED "equiv1"
#define PRED       X657175697631
#define ARITY      2

Begin_Public_Pred
      get_x_value(0,1)
      proceed

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "at_least_one"
#define PRED       X61745F6C656173745F6F6E65
#define ARITY      1

Begin_Public_Pred
      put_integer(1,1)
      execute(Pred_Name(X61745F6C656173745F6F6E6531,2),1,"at_least_one1",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "at_least_one1"
#define PRED       X61745F6C656173745F6F6E6531
#define ARITY      2

Begin_Private_Pred
      switch_on_term(G_label(2),fail,fail,G_label(1),fail)

label(1)
      try(3,1)          /* begin sub 1 */
      trust(5)

label(2)
      try_me_else(4)

label(3)
      get_list(0)
      unify_x_variable(0)
      unify_nil
      get_x_value(0,1)
      proceed

label(4)
      trust_me_else_fail

label(5)
      allocate(3)
      get_list(0)
      unify_y_variable(2)
      unify_x_variable(0)
      get_y_variable(0,1)
      put_y_variable(1,1)
      call(Pred_Name(X61745F6C656173745F6F6E6531,2),1,2,"at_least_one1",2)          /* begin sub 2 */
      put_y_value(2,0)
      put_y_unsafe_value(1,1)
      put_y_value(0,2)
      deallocate
      execute(Pred_Name(X6F72,3),1,"or",3)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "at_most_one"
#define PRED       X61745F6D6F73745F6F6E65
#define ARITY      1

Begin_Public_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(1)
      get_list(0)
      unify_x_variable(1)
      unify_y_variable(0)
      put_y_value(0,0)
      call(Pred_Name(X6E6F745F74776F,2),1,1,"not_two",2)          /* begin sub 1 */
      put_y_value(0,0)
      deallocate
      execute(Pred_Name(X61745F6D6F73745F6F6E65,1),1,"at_most_one",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "not_two"
#define PRED       X6E6F745F74776F
#define ARITY      2

Begin_Private_Pred
      switch_on_term(G_label(1),G_label(2),fail,G_label(4),fail)

label(1)
      try_me_else(3)

label(2)
      get_nil(0)
      proceed

label(3)
      trust_me_else_fail

label(4)
      allocate(2)
      get_list(0)
      unify_x_variable(0)
      unify_y_variable(1)
      get_y_variable(0,1)
      put_y_value(0,1)
      call(Pred_Name(X616E6430,2),1,1,"and0",2)          /* begin sub 1 */
      put_y_value(1,0)
      put_y_value(0,1)
      deallocate
      execute(Pred_Name(X6E6F745F74776F,2),1,"not_two",2)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY



#define ASCII_PRED "only_one"
#define PRED       X6F6E6C795F6F6E65
#define ARITY      1

Begin_Public_Pred
      allocate(1)
      get_y_variable(0,0)
      put_y_value(0,0)
      call(Pred_Name(X61745F6C656173745F6F6E65,1),1,1,"at_least_one",1)          /* begin sub 1 */
      put_y_value(0,0)
      deallocate
      execute(Pred_Name(X61745F6D6F73745F6F6E65,1),1,"at_most_one",1)

End_Pred

#undef ASCII_PRED
#undef PRED
#undef ARITY


Begin_Init_Tables(b_bips)

 Define_Atom(X5B5D,"[]")
 Define_Atom(X6E6F74,"not")
 Define_Atom(X616E64,"and")
 Define_Atom(X6F72,"or")
 Define_Atom(X616E6430,"and0")
 Define_Atom(X6F7231,"or1")
 Define_Atom(X786F72,"xor")
 Define_Atom(X6571756976,"equiv")
 Define_Atom(X657175697631,"equiv1")
 Define_Atom(X61745F6C656173745F6F6E65,"at_least_one")
 Define_Atom(X61745F6C656173745F6F6E6531,"at_least_one1")
 Define_Atom(X61745F6D6F73745F6F6E65,"at_most_one")
 Define_Atom(X6E6F745F74776F,"not_two")
 Define_Atom(X6F6E6C795F6F6E65,"only_one")


 Define_Pred(X6E6F74,2,1)

 Define_Pred(X616E64,3,1)

 Define_Pred(X6F72,3,1)

 Define_Pred(X616E6430,2,1)

 Define_Pred(X6F7231,2,1)

 Define_Pred(X616E6430,3,1)

 Define_Pred(X6F7231,3,1)

 Define_Pred(X786F72,3,1)

 Define_Pred(X6571756976,3,1)

 Define_Pred(X657175697631,2,1)

 Define_Pred(X61745F6C656173745F6F6E65,1,1)

 Define_Pred(X61745F6C656173745F6F6E6531,2,0)

 Define_Pred(X61745F6D6F73745F6F6E65,1,1)

 Define_Pred(X6E6F745F74776F,2,0)

 Define_Pred(X6F6E6C795F6F6E65,1,1)

 Init_Usr_File

End_Init_Tables


Begin_Exec_Directives(b_bips)



End_Exec_Directives
